package jTunnel;

import java.net.*;
import java.io.*;
import java.util.StringTokenizer;


/**
 * @see jTunnel.Ojt
 * @version 1.0b3 10/04/98
 * @author Pierre-Mikael legris (plegris@fbwww.epfl.ch) 
 * @author Philippe Rochat (Philippe.Rochat@epfl.ch)
 */
public class Ijt implements Runnable
{
  String outsideHost;
  int hostPort;
  boolean Mb = false;
  static int WaitTime;

  Thread connector, connection;


  // IJT
  public Ijt(String o_host, int h_port)
  {
    outsideHost = o_host;
    hostPort = h_port;
    
    log("IJT started : Outside host = " + outsideHost + ": " + hostPort );
   
    connector = new Thread(this);
    connector.setPriority(Thread.MIN_PRIORITY);
    connector.start();
  }
  
  // Main
  /**
   * Usage:  ijt <outside host> <host port> <wait time (min)>
   */
  public static void main(String args[]) 
  {
    String outsideHost = "";
    int hostPort = 0;
   
    if(args.length != 3)
      {
	 System.out.println("ijt: usage: ijt <outside host> <host port> <wait time (min)>");
	System.exit(1);
      }
    try {
      outsideHost =  args[0];
      hostPort = Integer.parseInt(args[1]);
      WaitTime = Integer.parseInt(args[2]);
    } catch(Exception e) {
       System.out.println("ijt: usage: ijt <outside host> <host port> <wait time (min)>");
      System.exit(1);
    }
   
    
    Ijt me = new Ijt(outsideHost, hostPort);
  }

  // RUN
  public void run()
  {
    Socket Msocket = null;
    DataInputStream IM = null;
    PrintStream PIM = null;
    // try 1
    try {
      // Open Msocket and stream
      Msocket = new Socket(outsideHost,hostPort);
      IM = new DataInputStream(Msocket.getInputStream());
      PIM = new PrintStream(Msocket.getOutputStream());
      PIM.println("main");
      Mb = true;
    } // try 1
    catch(Exception e) {
      log("cannot connect!") ;
      Mb = false;
    }
    
    if (Mb) log("connected!"); 
    // lit le stream
    String ligne = "";

    while ( Msocket != null ) {
      // try 2
      try {
	ligne=IM.readLine();
	//Interprete la ligne
	Parse_l(ligne);
	// try 3
	try{
	  Thread.sleep(100);
	} // try 3  
	catch(InterruptedException e){ }
      }// try 2
      catch (Exception e) { 
	log("lost M connection"); 
	break;
      }
    }
    try {
      Thread.sleep(WaitTime * 60000);
    }
    catch(InterruptedException e){ }
    
    connector = new Thread(this);
    connector.setPriority(Thread.MIN_PRIORITY);
    connector.start();
  }
  
  // Parse the String and launch new Socket
  private void Parse_l(String ligne )
  {
    String id = "";
    String Dhost = "";
    int Dport = 0;
    
    StringTokenizer st = new StringTokenizer(ligne);
    if (st.countTokens() == 3) {
      id = st.nextToken();
      Dhost = st.nextToken();
      Dport = Integer.valueOf(st.nextToken()).intValue();
      New_R(id, Dhost, Dport); 
    } 
  }

  // Create a new Internal Socket , a Msocket, and redirect them 
  private void New_R(String id,String remoteHost,int remotePort) 
  {
    Socket localSocket = null;
    PrintStream PM = null;
    // try 1
    try {
      // Open NewMsocket and give it the id String
      localSocket = new Socket(outsideHost,hostPort);
      PM = new PrintStream(localSocket.getOutputStream());
      PM.println("id " + id );
    } // try 1
    catch(Exception e) {
      log("cannot create localSocket " + hostPort + " for:" + id) ;
    }
    
    // Redirect the whole stuff
    try {
      Socket destinationSocket = new Socket(remoteHost, remotePort);
      log("connecting "+localSocket.getInetAddress().getHostName()+" <-> "+
	  destinationSocket.getInetAddress().getHostName());
      redirector r1 = new redirector(localSocket, destinationSocket);
      redirector r2 = new redirector(destinationSocket, localSocket);
      r1.couple(r2);
      r2.couple(r1);
    } catch(Exception e) {
       System.out.println("Ijt: error: cannot create local sockets step2");
    }
    
  }  //New_R
  
  // LOG
  private void log(String msg)
  {
    System.out.println("Ijt: "+msg);
  } //LOG
}

